<template>
  <!-- 
    1.Ho sostituito il mixin cms-support.js per la gestione del tipo di prop con la composition function useCastPropToType.js

    2.Ho convertito l'option api in composition api
      da notare che il metodo created() nel setup non esiste più, in quanto il setup() viene eseguito nello stesso momento del created() quindi in vue3 anche il beforeCreate non esiste più.

    3. Il this.$el nel setup non è più disponibile, quindi ho assegnato una ref="el" al div, e definito una variabile 'el' nel setup() settata a null per poter catturare l'elemento html

    4. da notare che this.$nextTick viene ora sostitutito con una funzione indipendente importata da vue
   -->
  <div ref="el" class="JsLoader" />
</template>

<script>
import castPropToType from "../hooks/useCastPropToType.js";
import { ref, computed, nextTick } from "vue";
export default {
  name: 'JsLoader',
  props: {
    dataSrc: { type: String, required: true },
    dataAsync: { type: [String, Boolean], default: true },
    dataDefer: { type: [String, Boolean], default: false },
    dataType: { type: String, default: "text/javascript" },
    dataId: { type: String, required: false, default: null },
    dataExtraAttrs: { type: [String, Object], default: () => ({}) },
  },
  setup(props) {
    const el = ref(null);
    const isAsync = computed(() => {
      return castPropToType(props.dataAsync, "boolean");
    });

    const isDefer = computed(() => {
      return castPropToType(props.dataDefer, "boolean");
    });

    const extraAttrs = computed(() => {
      return castPropToType(props.dataExtraAttrs, "object");
    });

    let scriptTag = document.createElement("script");
    scriptTag.setAttribute("src", props.dataSrc);
    scriptTag.setAttribute("async", isAsync.value);
    scriptTag.setAttribute("defer", isDefer.value);
    scriptTag.setAttribute("type", props.dataType);
    if (props.dataId) {
      scriptTag.setAttribute("id", props.dataId);
    }
    Object.keys(extraAttrs.value).forEach((key) => {
      scriptTag.setAttribute(key, extraAttrs.value[key]);
    });
    nextTick(() => {
      if (props.dataId) {
        if (!document.getElementById(props.dataId)) {
          el.value.appendChild(scriptTag);
        }
      } else {
        el.value.appendChild(scriptTag);
      }
    });
    return {
      el
    };
  }
};
</script>
